package com.xxl.job.admin.core.thread;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.xxl.job.admin.core.conf.XxlJobAdminConfig;
import com.xxl.job.admin.core.trigger.TriggerTypeEnum;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.RejectedExecutionHandler;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JobTriggerPoolHelper {
  private static Logger logger = LoggerFactory.getLogger(com.xxl.job.admin.core.thread.JobTriggerPoolHelper.class);
  
  private ThreadPoolExecutor fastTriggerPool = null;
  
  private ThreadPoolExecutor slowTriggerPool = null;
  
  public void start() {
    this
      
      .fastTriggerPool = new ThreadPoolExecutor(10, XxlJobAdminConfig.getAdminConfig().getTriggerPoolFastMax(), 60L, TimeUnit.SECONDS, new LinkedBlockingQueue<>(2000), (ThreadFactory)new Object(this), (RejectedExecutionHandler)new Object(this));
    this
      
      .slowTriggerPool = new ThreadPoolExecutor(10, XxlJobAdminConfig.getAdminConfig().getTriggerPoolSlowMax(), 60L, TimeUnit.SECONDS, new LinkedBlockingQueue<>(5000), (ThreadFactory)new Object(this), (RejectedExecutionHandler)new Object(this));
  }
  
  public void stop() {
    this.fastTriggerPool.shutdownNow();
    this.slowTriggerPool.shutdownNow();
    logger.info(">>>>>>>>> xxl-job trigger thread pool shutdown success.");
  }
  
  private volatile long minTim = System.currentTimeMillis() / 60000L;
  
  private volatile ConcurrentMap<Integer, AtomicInteger> jobTimeoutCountMap = new ConcurrentHashMap<>();
  
  public void addTrigger(int jobId, TriggerTypeEnum triggerType, int failRetryCount, String executorShardingParam, String executorParam, String addressList) {
    ThreadPoolExecutor triggerPool_ = this.fastTriggerPool;
    AtomicInteger jobTimeoutCount = this.jobTimeoutCountMap.get(Integer.valueOf(jobId));
    if (jobTimeoutCount != null && jobTimeoutCount.get() > 10)
      triggerPool_ = this.slowTriggerPool; 
    triggerPool_.execute((Runnable)new Object(this, jobId, triggerType, failRetryCount, executorShardingParam, executorParam, addressList));
  }
  
  private static com.xxl.job.admin.core.thread.JobTriggerPoolHelper helper = new com.xxl.job.admin.core.thread.JobTriggerPoolHelper();
  
  public static void toStart() {
    helper.start();
  }
  
  public static void toStop() {
    helper.stop();
  }
  
  public static void trigger(int jobId, TriggerTypeEnum triggerType, int failRetryCount, String executorShardingParam, String executorParam, String addressList) {
    helper.addTrigger(jobId, triggerType, failRetryCount, executorShardingParam, executorParam, addressList);
  }
}
